#include "SplitPlugin.h"
using namespace std;

/******************************/
// Split Plugin 
/******************************/


//Split::Split(DimsCHW Data, DimsCHW RB):dimsData(Data),dimsRB(RB){}
Split::Split(){}

Split::Split(const void* buffer, size_t length)
{
    const char *d = reinterpret_cast<const char*>(buffer), *a = d;
    read(d, mAxis);
    read(d, mNumSplit);
    read(d, mInputDims.d[0]);
    read(d, mInputDims.d[1]);
    read(d, mInputDims.d[2]);
    read(d, mOutputDims.d[0]);
    read(d, mOutputDims.d[1]);
    read(d, mOutputDims.d[2]);
    assert(d == a + length);
}


int Split::getNbOutputs() const{

    return 3;
}
Dims Split::getOutputDimensions(int index, const Dims* inputs, int nbInputDims) 
{
    std::cout << "inputDims 0:" << inputs[0].d[0] <<" " << inputs[0].d[1] << " " << inputs[0].d[2] << std::endl;
    //the input dims in inputs[1], it is also very strange.
    std::cout << "inputDims 1:" << inputs[1].d[0] <<" " << inputs[1].d[1] << " " << inputs[1].d[2] << std::endl;

    mAxis = 3;
    mNumSplit = 3;
    std::cout << "getOutputDimensions index: " << index << std::endl;
    std::cout << "nbInputDims" << nbInputDims << std::endl;
    //assert(nbInputDims == 2);
    int axis_value = mAxis;
    int num_splits = mNumSplit;
    int input_dims = 4;
    if (axis_value < 0) {
        axis_value += input_dims;
    }
    assert(axis_value >= 1);
    assert(axis_value < input_dims);

    const int input_size = inputs[1].d[axis_value];
    //assert(input_size % num_splits == 0 && "Not an even split.");
    const int slice_size = input_size / num_splits;

    mOutputDims.d[0]= inputs[1].d[1];
    mOutputDims.d[1] = inputs[1].d[2];
    mOutputDims.d[2] = inputs[1].d[0];
    mOutputDims.d[2] = inputs[1].d[0] / num_splits;

    mInputDims.d[0] = inputs[1].d[1];
    mInputDims.d[1] = inputs[1].d[2];
    mInputDims.d[2] = inputs[1].d[0];


    return DimsCHW(5,5,1);
}

int Split::initialize()
{
    return 0;
}

void Split::terminate()
{

}

//currently it is not possible for a plugin to execute "in place". 
//Therefore we memcpy the data from the input to the output buffer


int Split::enqueue(int batchSize, const void* const* inputs, void** outputs, void*, cudaStream_t stream)
{
    const float* input = reinterpret_cast<const float*>(inputs[1]);
    int input_num = 5 * 5 * 3;
    std::vector<float> inputTemp(input_num);
    CHECK(cudaMemcpyAsync((char *)&inputTemp[0], input, input_num * sizeof(float), cudaMemcpyDeviceToHost, stream));
    
    for (int i =0; i < input_num; i ++ ){
     std::cout << "input_enqueue "<< i << " : "<< inputTemp[i] << std::endl;
    }

    int output_num =  5 * 5;
    float* output_0 = reinterpret_cast<float*>(outputs[0]);
    float* output_1 = reinterpret_cast<float*>(outputs[1]);
    float* output_2 = reinterpret_cast<float*>(outputs[2]);
    CHECK(cudaMemcpyAsync(output_0, (char *)&inputTemp[0], output_num * sizeof(float)  , cudaMemcpyHostToDevice, stream));
    CHECK(cudaMemcpyAsync(output_1, (char *)&inputTemp[output_num], output_num * sizeof(float) , cudaMemcpyHostToDevice, stream));
    CHECK(cudaMemcpyAsync(output_2, (char *)&inputTemp[output_num*2], output_num * sizeof(float) , cudaMemcpyHostToDevice, stream));
    
    return 0;   
}


size_t Split::getSerializationSize()
{
    return sizeof(int) * 2 + sizeof(int) * 3 * 2;
    return 0;
}


void Split::serialize(void* buffer)
{
    //std::cout << "serialize" << std::endl;
    char *d = reinterpret_cast<char*>(buffer), *a = d;
    write(d, mAxis);
    write(d, mNumSplit);
    write(d, mInputDims.d[0]);
    write(d, mInputDims.d[1]);
    write(d, mInputDims.d[2]);
    write(d, mOutputDims.d[0]);
    write(d, mOutputDims.d[1]);
    write(d, mOutputDims.d[2]);

    assert(d == a + getSerializationSize());
}


void Split::configure(const Dims* inputs, int nbInputs, const Dims* outputs, int nbOutputs, int)
{
}



/******************************/
// PluginFactory
/******************************/
nvinfer1::IPlugin* PluginFactory::createPlugin(const char* layerName, const nvinfer1::Weights* weights, int nbWeights, const nvuffparser::FieldCollection rp)
{
    assert(isPlugin(layerName));
    std::cout<<'layerName'<< layerName << std::endl;
    if (strstr(layerName, "Split"))
    {
        assert(mSplit == nullptr);
        assert(nbWeights == 0 && weights == nullptr);
        mSplit = std::unique_ptr<Split>(new Split());
        return mSplit.get();
    }
    else
    {
        assert(0);
        return nullptr;
    }
}


IPlugin* PluginFactory::createPlugin(const char* layerName, const void* serialData, size_t serialLength)
{
    assert(isPlugin(layerName));
    if (strstr(layerName, "Split"))
    {
        assert(mSplit == nullptr);
        mSplit = std::unique_ptr<Split>(new Split(serialData, serialLength));
        return mSplit.get();
    }
    else
    {
        assert(0);
        return nullptr;
    }
    
}

bool PluginFactory::isPlugin(const char* name)
{
    std::cout << "layerName:" << name<<std::endl;
    return (strstr(name, "Split"));
}

void PluginFactory::destroyPlugin()
{
    mSplit.release();
    mSplit = nullptr;
}